#include "testlib.h"
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

const long long MAX =  1'000'000'000;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    vector<int> d(2 * n);

    int f = inf.readInt();
    if (f == 1) {
        for (int i = 0; i < n; i++) {
            d[i] = inf.readInt();
        }
    } else {
        int m;
        m = inf.readInt();
        long long x = inf.readLong();
        long long y = inf.readLong();
        long long z = inf.readLong();
        for (int i = 0; i < m; i++) {
            d[i] = inf.readInt();
        }
        for (int i = m; i < n; i++) {
            d[i] = (d[i - 2] * x + d[i - 1] * y + z) % MAX + 1;
        }
    }

    long long ja = ans.readLong();
    long long pa = ouf.readLong();
    if (ja < pa) {
        quitf(_wa, "expected: %d, found: %d", ja, pa);
    }
    int s = ouf.readInt(1, n) - 1;
    long long c = pa;
    for (int i = 0; i < n; i++) {
        if (c < d[(s + i) % n]) {
            quitf(_wa, "cannot jump from %d to %d, power %d, distance %d", (s + i) % n + 1, (s + i + 1) % n + 1, c, d[(s + i) % n]);
        }
        c++;
    }

    if (pa < ja) {
        quitf(_fail, "expected: %d, found: %d", ja, pa);
    }

    quitf(_ok, "%d %d", ja, s);
}
