//  Copyright 2021 Nikita Golikov

#include <bits/stdc++.h>

using namespace std;

using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;

#ifdef GOLIKOV
    #define debug(x) cerr << (#x) << ":\t" << (x) << endl
#else
    #define debug(x) 238;
#endif

template <class A, class B>
bool smin(A &x, B &&y) {
  if (y < x) {
    x = y;
    return true;
  }
  return false;
}

template <class A, class B>
bool smax(A &x, B &&y) {
  if (x < y) {
    x = y;
    return true;
  }
  return false;
}

template <class T, class Compare = less<T>>
struct min_queue {
  deque<pair<int, T>> q;
  int l{};
  int r{};
  Compare cmp{};

  void clear() {
    l = 0;
    r = 0;
    q.clear();
  }

  void push(T const& x) {
    while (!q.empty() && !(cmp(q.back().second, x))) {
      q.pop_back();
    }
    q.emplace_back(r++, x);
  }

  void pop() {
    if (l++ == q.front().first) q.pop_front();
  }

  [[nodiscard]] T get() const {
    return q.front().second;
  }

  [[nodiscard]] int size() const {
    return r - l;
  }

  [[nodiscard]] bool empty() const {
    return l == r;
  }
};

int main() {
#ifdef GOLIKOV
  assert(freopen("in", "rt", stdin));
  auto _clock_start = chrono::high_resolution_clock::now();
#endif
  ios::sync_with_stdio(false);
  cin.tie(nullptr);

  int n, f;
  cin >> n >> f;
  vector<int> a(2 * n - 1);
  if (f == 1) {
    for (int i = 0; i < n; ++i) {
      cin >> a[i];
    }
  } else {
    int const MOD = int(1e9);

    int m, x, y, z;
    cin >> m >> x >> y >> z;
    for (int i = 0; i < m; ++i) {
      cin >> a[i];
    }
    for (int i = m; i < n; ++i) {
      a[i] = int((ll(z) + ll(y) * a[i - 1] + ll(x) * a[i - 2]) % MOD) + 1;
    }
  }
  for (int i = n; i < 2 * n - 1; ++i) {
    a[i] = a[i - n];
  }
  for (int i = 0; i < 2 * n - 1; ++i) {
    a[i] -= i;
  }

  min_queue<int, greater<int>> minq;
  for (int i = 0; i < n; ++i) {
    minq.push(a[i]);
  }
  int ans = minq.get();
  int who = 0;
  for (int i = 1; i < n; ++i) {
    minq.pop();
    minq.push(a[n + i - 1]);
    if (smin(ans, minq.get() + i)) {
      who = i;
    }
  }
  cout << ans << ' ' << who + 1 << '\n';

#ifdef GOLIKOV
  cerr << "Executed in " << chrono::duration_cast<chrono::milliseconds>(
      chrono::high_resolution_clock::now()
          - _clock_start).count() << "ms." << endl;
#endif
  return 0;
}
